'''
Created on 3 nov. 2018

@author: invite

'''
import random
import Conf


class Bloc:
    '''
    classdocs
    '''


    def __init__(self,** keys):
        
        random.seed()
        self.drivethrough=False
        self.option=[]
        self.raised=False
        
        if 'type' in keys :
            self.type=keys['type']
        elif random.random() > Conf.ratioPyramid:
            self.type="box"
        else:
            self.type="pyramid"
        
        if 'c' in keys :
            self.c=keys['c']
        else:
            self.c=None
            
        if 'sx' in keys :
            self.sx=abs(int(keys['sx']))
        else:
            self.sx=random.randint(Conf.blocSxMin,Conf.blocSxMax)
            
        if 'sy' in keys :
            self.sy=abs(int(keys['sy']))
        else:
            self.sy=random.randint(Conf.blocSyMin,Conf.blocSyMax)
            
        if 'sz' in keys :
            self.sz=int(self.standardizeSz(keys['sz']))
        else:
            self.sz=int(self.standardizeSz(random.randint(Conf.blocSzMin,Conf.blocSzMax)))
        
        if 'px' in keys :
            self.px=int(keys['px'])
        else:
            self.px=random.randint(0,2*Conf.worldSize)
            
            
        if 'py' in keys :
            self.py=int(keys['py'])
        else:
            self.py=random.randint(0,2*Conf.worldSize)
            
            
        if 'pz' in keys :
            self.pz=int(keys['pz'])
        else:
            self.pz=0
            

            
        if 'shootthrough' in keys :
            self.shootthrough=keys['shootthrough']
        else:
            self.shootthrough=False
            
        if 'matref' in keys :
            self.matref=keys['matref']
        else:
            self.matref=None
        
        if 'protection' in keys :
            self.protection=keys['protection']
        else:
            self.protection=0
            
        if 'rotation' in keys :
            self.rotation=keys['rotation']
        else:    
            random.seed()
            self.rotation=int(360*random.random())

        if 'option' in keys :
            self.option.append(keys['option'])

        if 'name' in keys :
            self.name=keys['name']
        else:
            self.name=None
            
        if 'color' in keys :
            self.color=keys['color']
        elif self.name!=None:
            if self.name=="bigBloc":
                self.color=Conf.colorBigBloc
            elif self.name=="montagne":
                self.color=Conf.colorMontagne
            elif self.name=="stepBloc":
                self.color=Conf.colorStepBloc
            elif self.name=="baseWay":
                self.color=Conf.colorBaseWay
            elif self.name=="Forest":
                self.color=Conf.colorForest
            elif self.name=="Circle":
                self.color=Conf.colorCircle
            elif self.name=="baseWayPyra":
                self.color=None
            else :
                #print("#Bloc : no color for this bloc name "+self.name)
                self.color=None
            
        else:
            self.color=None
            
        self.sym=None
        
    def getSurface(self):
        return self.sx*self.sy
    
    def cloneCtf(self):
        
        if self.rotation is None:
            self.rotation=0
            
        r=self.rotation+180
        if r>=360:
            r-=360
        
        px,py=self.symetrieAxiale(self.px, self.py)
        
        c=Bloc(sx=self.sx,sy=self.sy,sz=self.sz,px=px,py=py,pz=self.pz,shootthrough=self.shootthrough, \
            #color=self.color,protection=self.protection,type=self.type,rotation=r,c=self.c,name=self.name,sym=self)
            color=self.color,protection=self.protection,type=self.type,rotation=r,c=self.c,name=self.name)
        c.setOption(self.getOption())
        #self.setSym(c)
        
        return c
    
        
    def draw(self):
        
        if self.type == "base":
            self.sz+=0.1

        
        if self.type=="pyramid" or self.type=="meshpyr":
            if random.random() <= Conf.ratioMeshpyr and self.sz>0 :
                # PB AVEC MESHPYR WITH NEGATIVE PZ
                self.drivethrough=True
                self.color=Conf.colorMeshpyr
                self.type="meshpyr"
            
        #***
        # main part
        #***
        print("# "+str(self.name))
        print (self.type)
        print ("  position "+str(self.px-Conf.worldSize)+" "+str(self.py-Conf.worldSize)+" "+str(self.pz))     
        print ("  size "+str(self.sx)+" "+str(self.sy)+" "+str(self.sz))
        print ("  rotation "+str(self.rotation))
        
        if len(self.option) !=0 :
            for option in self.option:
                print ("  "+str(option))

        if self.matref != None:
            print ("   matref "+self.matref)
                
        if self.color != None:
            print ("  color "+self.color)
            
        if self.shootthrough is True:
            print("  shootthrough")
                
        if self.drivethrough is True:
            print("   drivethrough")
               
        print ("end")

    def getC(self):
        return self.c
    
    def getColor(self):
        return self.color
    
    def getDriveThrough(self):
        return self.drivethrough
    
    def getName(self):
        return self.name
    
    def getPx(self):
        return self.px
    
    def getPy(self):
        return self.py
                
    def getPz(self):
        return self.pz  
                    
    def getRotation(self):
        return self.rotation  
    
    def getSx(self):
        return self.sx
    
    def getSy(self):
        return self.sy
    
    def getSym(self):
        return self.sym
        
    def getSz(self):
        return self.sz
    
    def getType(self):
        return self.type

    def getOption(self):
        return self.option
    
    def getProtection(self):    
        return self.protection 
         
             
    def isRaised(self):
        return self.raised
    
    def standardizeSz(self,sz):
        u=Conf.stepHight
 
        #gateway case and small bloc sz < u/2
        if sz <= u/2:
            return sz
        
        n=int(sz/u)
        if sz%u > u/2 :
            ssz=(n+1)*u
        else:
            ssz=n*u
        return ssz
        
    def symetrieAxiale(self,x,y):
        if x>Conf.worldSize:
            px=Conf.worldSize-(x-Conf.worldSize)
        else:
            px=Conf.worldSize+(Conf.worldSize-x)
            
        if y>Conf.worldSize:
            py=Conf.worldSize-(y-Conf.worldSize)
        else:
            py=Conf.worldSize+(Conf.worldSize-y)
            
        return px,py
         
    def setIsRaised(self,b):
        self.raised=b
        
    def setColor(self,c):
        self.color=c
        
    def setDriveThrough(self,b):
        self.drivethrough=b
        
    def setMatRef(self,matref):
        self.matref=matref
        
    def setOption(self,option):
        self.option=option
        
    def setPx(self,px):
        self.px=abs(int(px))
    
    def setPy(self,py):
        self.py=abs(int(py))
            
    def setPz(self,pz):
        self.pz=int(pz)
    
    def setProtection(self,n):    
        self.protection=n

    def setSx(self,sx):
        self.sx=int(sx)
    
    def setSy(self,sy):
        self.sy=int(sy)
    
    def setSym(self,sym):
        self.sym=sym
            
    def setSz(self,sz):
        #self.sz=int(self.standardizeSz(sz))
        self.sz=int(sz)
        
    def setRotation(self,r):
        self.rotation=int(r)
    
    def setType(self,t):
        self.type=t
    
    def toString(self):
        print("bloc name "+str(self.name))
        print("bloc type "+self.type)
        print("bloc sx "+str(self.sx))
        print("bloc sy "+str(self.sy))
        print("bloc sz "+str(self.sz))
        print("bloc px "+str(self.px))
        print("bloc py "+str(self.py))
        print("bloc pz "+str(self.pz))
        print("bloc rotation "+str(self.rotation))
        print("bloc color "+str(self.color))
        print("bloc protection "+str(self.protection))

        if len(self.option)!=0:
            for o in self.option:
                print("bloc option "+str(o))
                
        return
                    
    def translate(self,x,y):
        return  x-Conf.worldSize,y-Conf.worldSize
    
    def xShift(self,x):
        self.px=self.px+int(x)
        
    def yShift(self,y):
        self.py=self.py+int(y)
        
    def zShift(self,z):
        self.pz=self.pz+int(z)
        
