'''
Created on 4 nov. 2018

@author: invite
'''
from math import cos
from math import sin
from math import pi
from math import atan
import Conf
import random
from StepBloc import StepBloc
from BlocGroup import BlocGroup
from Bloc import Bloc


class GroupCircle(BlocGroup):

    def __init__(self, ** keys):
        
        BlocGroup.__init__(self)
        
        self.shZ=Conf.stepHight
        
        if 'blocSize' in keys :
            self.blocSize=keys['blocSize']
        else:
            self.blocSize="fixe"   
       
        if 'blocRotation' in keys :
            self.blocRotation=keys['blocRotation']
        else:
            if random.random() < 0.5:
                self.blocRotation=False
            else:   
                self.blocRotation=True
                
        self.blocRotation=True
        
        if 'rayon' in keys :
            self.rayon=keys['rayon']
        else:
            self.rayon=random.randint(Conf.circleRayonMin,Conf.circleRayonMax)

            print ("circle need rayon")
            exit()

        if 'name' in keys :
            self.name=keys['name']
        else:
            self.name="Circle"
         
        if 'shX' in keys :
            self.shX=keys['shX']
        else:
            self.shX=Conf.worldSize
        
        if 'shY' in keys :
            self.shY=keys['shY']
        else:
            self.shY=Conf.worldSize
            
        if 'sz' in keys:
            self.sz=keys['sz']
        else:
            self.sz=None
            
        self.genCircle()
   
        self.shift()
        
       
    def genCircle(self):       
        random.seed

        if self.blocSize=="fixe" :
            sx=random.randint(Conf.circleSideSizeMin,Conf.circleSideSizeMax)
            sy=random.randint(int(sx/2),round(sx*2))
            
            if self.sz != None:
                sz=self.sz
            else:
                sz=random.randint(Conf.circleSizeZmin,Conf.circleSizeZmax)
                
            type="meshbox"
             
            rad=random.randint((3*sx)+Conf.gap,(6*sx)+Conf.gap)
                           
        elif self.blocSize=="variable":
            s=int(Conf.circleSideSizeMax)
            rad=random.randint((3*s)+Conf.gap,(6*s)+Conf.gap)
            
        protection=Conf.protectionCircle
        i=0
        circonference=2*pi*self.rayon

        while i <  circonference:
            a=i/self.rayon
            
            if self.blocSize=="variable":
                sx=random.randint(Conf.circleSideSizeMin,Conf.circleSideSizeMax)
                sy=random.randint(Conf.circleSideSizeMin,Conf.circleSideSizeMax)
                if self.sz != None:
                    sz=self.sz
                else:
                    sz=random.randint(Conf.circleSizeZmin,Conf.circleSizeZmax)
                
                if random.random() < Conf.ratioPyramid:
                    type="meshpyr"
                else:
                    type="meshbox"
                
                self.c.append(Bloc(px=self.rayon*cos(a),\
                py=self.rayon*sin(a),\
                sx=sx, \
                sy=sy, \
                sz=sz,\
                protection=protection,\
                name=self.name,\
                type=type))
            
                
            if self.blocSize=="fixe":
                rotation=((a*180)/pi)+90
                   
                self.c.append(Bloc(px=self.rayon*cos(a),\
                    py=self.rayon*sin(a),\
                    sx=sx, \
                    sy=sy, \
                    sz=sz,\
                    rotation=rotation,\
                    protection=protection,\
                    name=self.name,\
                    type=type))
                
            i=i+rad
        