'''
Created on 27 nov. 2018

@author: invite
'''

import random
import math
import Conf
from Bloc import Bloc
import Material
from BlocGroup import BlocGroup

class Montagne(BlocGroup):

    def __init__(self, ** keys):       
     
        random.seed()
        
        self.c=[]
        self.matrice=[]
        self.surface=0
        #self.shX=0
        #self.shY=0
        #self.shZ=0
        self.rotation=0
        self.shootthrough=False
        #self.color=Conf.colorMontagne
        
        self.name="montagne"

        if 'hight' in keys :
            self.hight=keys['hight']
        else:
            print("Montagne need hight")
            exit(1)
            
        if 'step' in keys :
            self.step=keys['step']
        else:
            print("Montagne need step")
            exit(1)
            
        if 'protection' in keys :
            self.protection=keys['protection']
        else:
            self.protection=0
            
            
        if 'sizeX' in keys :
            self.sizeX=keys['sizeX']
        else:
            print("Montagne need sizeX")
            exit(1)
            
        if 'sizeY' in keys :
            self.sizeY=keys['sizeY']
        else:
            print("Montagne need sizeY")
            exit(1)
        
        if 'montagneSizeX' in keys :
            self.montagneSizeX=keys['montagneSizeX']
        else:
            print("Montagne need montagneSizeX")
            exit(1)
        
        if 'montagneSizeY' in keys :
            self.montagneSizeY=keys['montagneSizeY']
        else:
            print("Montagne need montagneSizeY")
            exit(1)
        
        if 'centerX' in keys :
            self.centerX=keys['centerX']
        else:
            print("Montagne need centerX")
            exit(1)
        
        if 'centerY' in keys :
            self.centerY=keys['centerY']
        else:
            print("Montagne need centerY")
            exit(1)
               
        if 'flag' in keys :
            self.flag=keys['flag']
        else:
            self.flag=False
            
        matriceSide=round(Conf.worldSize/((Conf.montagneBlocSizeXmin+Conf.montagneBlocSizeYmin)/2))
        
        for x in range(0,matriceSide):
            self.matrice.append([])
            for y in range(0,matriceSide):
                self.matrice[x].append(None)
                    
        
        # the top of the  hill
        x=round(matriceSide/2)
        y=round(matriceSide/2)
        self.matrice[x][y]=Bloc(sx=self.sizeX,sy=self.sizeY,sz=self.hight,shootthrough=self.shootthrough,type="meshbox",protection=self.protection,\
                                name="montagne",px=self.centerX,py=self.centerY,rotation=self.rotation,c=self.c)
        
        if self.hight >= (3*Conf.stepHight) and self.flag==True:
            self.c.append(Bloc(sx=self.sizeX,sy=self.sizeY,sz=self.hight,type="zone",option="zoneflag GM 1", \
                               px=self.centerX,py=self.centerY,pz=self.hight,rotation=self.rotation,c=self.c,protection=self.protection))
        
        # list of the new blocs
        list=[]
        list.append([x,y])   
        
        #nbStep=1
        #nbBlocsToAddPerBloc=random.randint(1,3)
        sizeZ=self.hight-self.step
        i=1
        #print("montagneSize X Y :"+str(self.montagneSizeX)+"/"+str(self.montagneSizeY))
        
        while sizeZ > 3:
            #print("mountain step: "+str(sizeZ))
            
            #k coef de croissance ...
            k=i**2
            nbBlocsToAdd=random.randint(round(k/2),k)
            i+=1
            
            while nbBlocsToAdd > 0:
                
                # on choisi un bloc au hasard dans la montagne
                indexMax=len(list)-1
                #print("indexMax "+str(indexMax))
                j=random.randint(0,indexMax)
                
                x,y=list[j]
                o=self.matrice[x][y]
                px=o.getPx()
                py=o.getPy()
                nbBlocsToAddPerBloc=random.randint(0,3)
                
                while nbBlocsToAddPerBloc > 0:
                    #if nbBlocsToAdd <=0:
                    #    raise BreakIt
                    #print("nbBlocsToAddPerBloc: "+str(nbBlocsToAddPerBloc))
                    if self.matrice[x-1][y+1] == None:
                        self.matrice[x-1][y+1]=Bloc(sx=self.sizeX,sy=self.sizeY,sz=sizeZ,type="meshbox",shootthrough=self.shootthrough,name="montagne",px=px-(2*self.sizeX),py=py+(2*self.sizeY),rotation=self.rotation,c=self.c)
                        list.append([x-1,y+1])
                        nbBlocsToAddPerBloc -= 1
                        nbBlocsToAdd -= 1
                        self.surface+= self.sizeX*self.sizeY
                        continue
                    if self.matrice[x-1][y] == None:
                        self.matrice[x-1][y]=Bloc(sx=self.sizeX,sy=self.sizeY,sz=sizeZ,type="meshbox",shootthrough=self.shootthrough,name="montagne",px=px-(2*self.sizeX),py=py,rotation=self.rotation,c=self.c)
                        list.append([x-1,y])
                        nbBlocsToAddPerBloc -= 1
                        nbBlocsToAdd -= 1
                        self.surface+= self.sizeX*self.sizeY
                        continue
                    if self.matrice[x-1][y-1] == None:
                        self.matrice[x-1][y-1]=Bloc(sx=self.sizeX,sy=self.sizeY,sz=sizeZ,type="meshbox",shootthrough=self.shootthrough,name="montagne",px=px-(2*self.sizeX),py=py-(2*self.sizeY),rotation=self.rotation,c=self.c)
                        list.append([x-1,y-1])
                        nbBlocsToAddPerBloc -= 1
                        nbBlocsToAdd -= 1
                        self.surface+= self.sizeX*self.sizeY
                        continue
                    if self.matrice[x][y-1] == None:
                        self.matrice[x][y-1]=Bloc(sx=self.sizeX,sy=self.sizeY,sz=sizeZ,type="meshbox",shootthrough=self.shootthrough,name="montagne",px=px,py=py-(2*self.sizeY),rotation=self.rotation,c=self.c)
                        list.append([x,y-1])
                        nbBlocsToAddPerBloc -= 1
                        nbBlocsToAdd -= 1
                        self.surface+= self.sizeX*self.sizeY
                        continue
                    if self.matrice[x+1][y-1] == None:
                        self.matrice[x+1][y-1]=Bloc(sx=self.sizeX,sy=self.sizeY,sz=sizeZ,type="meshbox",shootthrough=self.shootthrough,name="montagne",px=px+(2*self.sizeX),py=py-(2*self.sizeY),rotation=self.rotation,c=self.c)
                        list.append([x+1,y-1])
                        nbBlocsToAddPerBloc -= 1
                        nbBlocsToAdd -= 1
                        self.surface+= self.sizeX*self.sizeY
                        continue
                    if self.matrice[x+1][y] == None:
                        self.matrice[x+1][y]=Bloc(sx=self.sizeX,sy=self.sizeY,sz=sizeZ,type="meshbox",shootthrough=self.shootthrough,name="montagne",px=px+(2*self.sizeX),py=py,rotation=self.rotation,c=self.c)
                        list.append([x+1,y])
                        nbBlocsToAddPerBloc -= 1
                        nbBlocsToAdd -= 1
                        self.surface+= self.sizeX*self.sizeY
                        continue
                    if self.matrice[x+1][y+1] == None:
                        self.matrice[x+1][y+1]=Bloc(sx=self.sizeX,sy=self.sizeY,sz=sizeZ,type="meshbox",shootthrough=self.shootthrough,name="montagne",px=px+(2*self.sizeX),py=py+(2*self.sizeY),rotation=self.rotation,c=self.c)
                        list.append([x+1,y+1])
                        nbBlocsToAddPerBloc -= 1
                        nbBlocsToAdd -= 1
                        self.surface+= self.sizeX*self.sizeY
                        continue
                    if self.matrice[x][y+1] == None:
                        self.matrice[x][y+1]=Bloc(sx=self.sizeX,sy=self.sizeY,sz=sizeZ,type="meshbox",shootthrough=self.shootthrough,name="montagne",px=px,py=py+(2*self.sizeY),rotation=self.rotation,c=self.c)
                        list.append([x,y+1])
                        nbBlocsToAddPerBloc -= 1
                        nbBlocsToAdd -= 1
                        self.surface+= self.sizeX*self.sizeY
                        continue
                    
                    del list[j]
                    break
                #list.remove([x,y])
                
                
            sizeZ -= self.step
 
 
        for x in range(0,matriceSide):
            for y in range(0,matriceSide):
                if self.matrice[x][y] != None:
                    self.c.append(self.matrice[x][y])
                

